Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:07 2011
FILE NAME: eccm.f90
PROGRAM NAME: eccm
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    97  vec  (   4): Vectorized array expression.
    98  vec  (   4): Vectorized array expression.
   101  vec  (   4): Vectorized array expression.
   108  vec  (   4): Vectorized array expression.
   133  vec  (   4): Vectorized array expression.
   135  vec  (   3): Unvectorized loop.
   205  vec  (   4): Vectorized array expression.
   206  vec  (   4): Vectorized array expression.
   209  vec  (   4): Vectorized array expression.
   214  vec  (   4): Vectorized array expression.
   224  vec  (   4): Vectorized array expression.
   232  vec  (   4): Vectorized array expression.
   278  vec  (   3): Unvectorized loop.
   334  vec  (   3): Unvectorized loop.
   334  vec  (   3): Unvectorized loop.
   335  vec  (   4): Vectorized array expression.
   335  vec  (   4): Vectorized array expression.
   343  vec  (   4): Vectorized array expression.
   348  vec  (   3): Unvectorized loop.
   408  vec  (   4): Vectorized array expression.
   416  vec  (   3): Unvectorized loop.
   464  vec  (   4): Vectorized array expression.
   466  vec  (   4): Vectorized array expression.
   466  vec  (   4): Vectorized array expression.
   511  vec  (   4): Vectorized array expression.
   511  vec  (   4): Vectorized array expression.
   512  vec  (   3): Unvectorized loop.
   513  vec  (   4): Vectorized array expression.
   513  vec  (   4): Vectorized array expression.
   523  opt  (1800): Idiom detected (matrix multiply).
   527  vec  (   4): Vectorized array expression.
   527  vec  (   4): Vectorized array expression.
   531  opt  (  11): Fused array assignments. :line 531 - 534
   531  vec  (   4): Vectorized array expression.
   531  vec  (   4): Vectorized array expression.
   536  opt  (  11): Fused array assignments. :line 536 - 538
   536  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:07 2011
FILE NAME: eccm.f90
PROGRAM NAME: eccm
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module ECCM
     2  !
     3  ! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
     4  ! Version::   $Id: eccm.f90,v 1.5 2011-06-03 06:11:22 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !ǮŪ˾徺뵤βٸΨ׻, ſ尵ʿդ鰵Ϥ
    12  !
    13  !== Error Handling
    14  !
    15  !== Known Bugs
    16  !
    17  !== Note
    18  !
    19  !  * Ǯ, ʿʬ̤
    20  !  * 顼٤­ʤΤ, 󥲥å.
    21  !
    22  !== Future Plans
    23  !
    24  
    25  module ECCM
    26  
    27    !⥸塼ɤ߹
    28    use dc_types, only : DP
    29    use dc_trace, only : DbgMessage
    30    use dc_message, only: MessageNotify
    31  
    32    use gridset,only: kmin,       &!  Z β
    33      &                 kmax,       &!  Z ξ
    34      &                 ncmax
    35    use axesset, only:  z_dz, r_dz      !
    36    use constants,only: MolWtDry,      &!
    37      &                 CpDryMol,      &!
    38      &                 TempSfc,       &!
    39      &                 PressSfc,      &!
    40      &                 Grav            !
    41    use chemcalc, only: SvapPress,        &!
    42      &                 LatentHeatPerMol, &!
    43      &                 ReactHeatNH4SHPerMol, &
    44      &                 DelMolFrNH4SH
    45    use composition, only: CondNum,          &!ŷο
    46      &                 SpcWetID,         &!
    47      &                 IdxCG,            &!ŷ()ź
    48      &                 IdxCC,            &!ŷ()ź
    49      &                 GasNum,           &!Το
    50      &                 IdxNH3,           &!NH3()ź
    51      &                 IdxH2S             !H2S()ź
    52    use ChemData, only: GasRUniv
    53  
    54    !ۤηػ
    55    implicit none
    56  
    57    !°λ
    58    private
    59  
    60    !ؿθ
    61    public ECCM_MolFr
    62    public ECCM_Stab
    63    public ECCM_Dry
    64    public ECCM_Wet
    65  
    66  contains
    67  
    68  !!!------------------------------------------------------------------------------!!!
    69    subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    70      !
    71      !== 
    72      !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    73      !  * Ǯϴ絤ΤΤɽ
    74      !    * ήΤˤǮϴʬΤΤɽƤ뤿
    75      !  * 絤ʿʬ̤ˤϼʬʬ̤
    76      !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    77      !
    78  
    79      !ۤηػ
    80      implicit none
    81  
    82      real(DP), intent(in) :: a_MolFrIni(1:ncmax)    !ǤΥ
    83      real(DP), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    84      real(DP), intent(out):: z_Temp(kmin:kmax) !
    85      real(DP), intent(out):: z_Press(kmin:kmax)!
    86      real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax)
    87                                                     !ʬΨ
    88      real(DP)             :: SatPress                !˰¾
    89      real(DP)             :: VapPress                !
    90      real(DP)             :: DelMolFr
    91      integer             :: k, s
    92  
    93      !-------------------------------------------------------------
    94      ! ν
    95      !-------------------------------------------------------------
    96      !ɽ̤ʬ̤
    97      za_MolFr  = 1.0d-60
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t209 = 1, ncmax*(kmax + 1 - kmin)                              
     .           za_molfr(t32+t209-1,1) = 9.99999999999999e-061                 
     .        end do                                                            
    98      za_MolFr(1, 1:ncmax) = a_MolFrIni(1:ncmax)
    99  
   100      !ɽ̤Ǥβ(nx ,  DelZ / 2 )
   101      z_Temp    = 1.0d-60
   102      z_Temp(1) = TempSfc - Grav * MolWtDry &
   103        &               / CpDryMol * ( z_dz(1) * 5.0d-1 )
   104  
   105  !    write(*,*) z_Temp(1)
   106  
   107      !ɽ̤Ǥΰ(1 ,  DelZ / 2 )
   108      z_Press    = 1.0d-60
   109      z_Press(1) = PressSfc *((TempSfc / z_Temp(1)) ** (- CpDryMol /  GasRUniv))
   110  
   111  !    write(*,*) z_Press(1)
   112  
   113      !-----------------------------------------------------------
   114      ! (1) Ǯ˱ä٤
   115      ! (2) ſ尵ʿդ鰵Ϥ
   116      ! (3) (1),(2) βٰϤФ, Ȥм٤Ȥʤ
   117      !-----------------------------------------------------------
   118      DtDz: do k = 1, kmax-1
   119  
   120        !(1)Ǯ˱ä k+1 Ǥβ٤׻
   121        z_Temp(k+1) = z_Temp(k) - Grav * MolWtDry / CpDryMol * r_dz(k)
   122  
   123        !ǰ
   124        if (z_Temp(k+1) <= 0.0d0 ) z_Temp(k+1) = z_Temp(k)
   125  
   126        !(2)Ϥſ尵ʿդ׻
   127        z_Press(k+1) =                                                  &
   128          &  z_Press(k) * ((z_Temp(k) / z_Temp(k+1)) ** (- CpDryMol / GasRUniv))
   129  
   130        !(3)η׻
   131        !  ޤϥѲʤΤȤƥͿ
   132        !  ˰¾ʿȤʿվŬѤƤ
   133        za_MolFr(k+1,:) = za_MolFr(k,:)
     .  !CDIR    NODEP                                                          
     .        do t225 = 1, ncmax                                                
     .           za_molfr(k+1,t225) = za_molfr(k,t225)                          
     .        end do                                                            
   134  
   135        do s = 1, CondNum
   136          !˰¾
   137          SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )
   138  
   139          !ΥʬΨѤƸߤξ׻
   140          VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
   141  
   142          !˰¾ȰϤ鸽ߤΥ׻
   143          if ( VapPress > SatPress ) then
   144            za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)
   145          end if
   146        end do
   147  
   148        !NH4SH ʿվ
   149        if ( IdxNH3 /= 0 ) then
   150          DelMolFr =                                              &
   151            & max (                                               &
   152            &    DelMolFrNH4SH(                                   &
   153            &         z_Temp(k+1), z_Press(k+1),                  &
   154            &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S), &
   155            &         Humidity                                    &
   156            &      ),                                             &
   157            &    0.0d0                                            &
   158            &  )
   159          za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
   160          za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
   161        end if
   162  
   163      end do DtDz
   164  
   165    end subroutine ECCM_Dry
   166  
   167  
   168  !!------------------------------------------------------------------------------!!!
   169    subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
   170      !
   171      !== 
   172      !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
   173      !  * Ǯϴ絤ΤΤɽ
   174      !    * ήΤˤǮϴʬΤΤɽƤ뤿
   175      !  * 絤ʿʬ̤ˤϼʬʬ̤
   176      !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
   177      !
   178  
   179      !ۤηػ
   180      implicit none
   181  
   182      real(DP), intent(in) :: a_MolFrIni(1:ncmax)    !ǤΥ
   183      real(DP), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
   184      real(DP), intent(out):: z_Temp(kmin:kmax) !
   185      real(DP), intent(out):: z_Press(kmin:kmax)!
   186                                                     !ʿʬ
   187      real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax)
   188                                                     !ʬΨ
   189      real(DP)             :: SatPress                !˰¾
   190      real(DP)             :: VapPress                !
   191      real(DP)             :: DelMolFr
   192      real(DP)             :: a_MolFr(ncmax)         !κ
   193      integer             :: k, s
   194  
   195      real(DP)             :: Temp1, Press1, DTempDZ1
   196      real(DP)             :: Temp2, Press2, DTempDZ2
   197      real(DP)             :: Temp3, Press3, DTempDZ3
   198      real(DP)             :: Temp4, Press4, DTempDZ4
   199      real(DP)             :: DTempDZ
   200  
   201      !-------------------------------------------------------------
   202      ! ν
   203      !-------------------------------------------------------------
   204      !ɽ̤ʬ̤
   205      za_MolFr  = 1.0d-60
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t323 = 1, ncmax*(kmax + 1 - kmin)                              
     .           za_molfr(t35+t323-1,1) = 9.99999999999999e-061                 
     .        end do                                                            
   206      za_MolFr(1, 1:ncmax)   = a_MolFrIni(1:ncmax)
   207  
   208      !ɽ̤Ǥβ(1 ,  DelZ / 2 )
   209      z_Temp          = 1.0d-60
   210      z_Temp(1) = TempSfc - Grav * MolWtDry  &
   211        &               / CpDryMol * ( z_dz(1) * 5.0d-1 )
   212  
   213      !ɽ̤Ǥΰ(1 ,  DelZ / 2 )
   214      z_Press           = 1.0d-60
   215      z_Press(1)  = &
   216        & PressSfc *((TempSfc / z_Temp(1)) ** (- CpDryMol /  GasRUniv))
   217  
   218      !-----------------------------------------------------------
   219      ! ǮΨ dT/dz η׻.
   220      !-----------------------------------------------------------
   221      DtDz: do k = 1, kmax-1
   222  
   223        !
   224        za_MolFr(k+1,:) = za_MolFr(k,:)
     .  !CDIR    NODEP                                                          
     .        do t339 = 1, ncmax                                                
     .           za_molfr(k+1,t339) = za_molfr(k,t339)                          
     .        end do                                                            
   225  
   226        !----------------------------------------------------
   227        !ǮΨ󥲥åˡѤƷ׻
   228        !----------------------------------------------------
   229        ! (0)  k Ǥͤݴ
   230        Temp1  = z_Temp(k)
   231        Press1 = z_Press(k)
   232        a_MolFr  = za_MolFr(k,:)
     .  !CDIR NODEP                                                             
     .        do t343 = 1, a_molfr.DSC.U1                                       
     .           a_molfr(t343) = za_molfr(k,t343)                               
     .        end do                                                            
   233  
   234        ! (1)  k ǤͤѤƲѲ׻
   235        call ECCM_DTempDZ( Temp1, Press1, r_dz(k), a_MolFr, DTempDZ1 )
   236  
   237        ! (2) (1) ǵ᤿ͤѤ,  k + k/2 ǤͤѤƲѲ׻
   238        !     ΤȤ, ʬ̤ѲʤΤȤ.
   239        Temp2  = Temp1 + DTempDZ1 * r_dz(k) * 5.0d-1
   240        Press2 =                                     &
   241          & Press1 * ((Temp1 / Temp3) ** (Grav * MolWtDry / (GasRUniv * DTempDZ2)))
   242        call ECCM_DTempDZ( Temp2, Press2, r_dz(k), a_MolFr, DTempDZ2 )
   243  
   244        ! (3) (2) ǵ᤿ͤѤ,  k + k/2 ǤͤѤƲѲ׻
   245        !     ΤȤ, ʬ̤ѲʤΤȤ.
   246        Temp3  = Temp1 + DTempDZ2 * r_dz(k) * 5.0d-1
   247        Press3 =                                                                   &
   248          & Press1 * ((Temp1 / Temp3) ** (Grav * MolWtDry / (GasRUniv * DTempDZ2)))
   249        call ECCM_DTempDZ( Temp3, Press3, r_dz(k), a_MolFr, DTempDZ3 )
   250  
   251        ! (4) (3) ǵ᤿ͤѤ,  k + k ǤͤѤƲѲ׻
   252        !     ΤȤ, ʬ̤ѲʤΤȤ.
   253        Temp4  = Temp1 + DTempDZ3 * r_dz(k)
   254        Press4 =                                               &
   255          & Press1 * ((Temp1 / Temp4) ** (Grav * MolWtDry / (GasRUniv * DTempDZ3)))
   256        call ECCM_DTempDZ( Temp4, Press4, r_dz(k), a_MolFr, DTempDZ4 )
   257  
   258        ! (5) ǽŪʷ
   259        DTempDZ = (DTempDZ1 + DTempDZ2 * 2.0d0 + DTempDZ3 * 2.0d0 + DTempDZ4) / 6.0d0
   260  
   261        !----------------------------------------------------
   262        !줿ٸΨ겹٤ȰϤ
   263        !----------------------------------------------------
   264        !٤׻
   265        z_Temp(k+1) = z_Temp(k) + DTempDz * r_dz(k)
   266  
   267        !ǰ
   268        if(z_Temp(k+1) < 0.0d0) z_Temp(k+1) = z_Temp(k)
   269  
   270        !Ϥſ尵ʿդ׻
   271        z_Press(k+1) =                                                  &
   272          &  z_Press(k) * ( ( z_Temp(k) / z_Temp(k+1))                  &
   273          &    ** (Grav * MolWtDry / ( DTempDZ * GasRUniv ) ) )
   274  
   275        !----------------------------------------------------
   276        !η׻
   277        !----------------------------------------------------
   278        do s = 1, CondNum
   279          !˰¾
   280          SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )
   281  
   282          !ΥʬΨѤƸߤξ׻
   283          VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
   284  
   285          !˰¾ȰϤ鸽ߤΥ׻
   286          if ( VapPress > SatPress ) then
   287            za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)
   288          end if
   289        end do
   290  
   291        !NH4SH ʿվ
   292        if ( IdxNH3 /= 0 ) then
   293          DelMolFr =                                              &
   294            & max (                                               &
   295            &    DelMolFrNH4SH(                                   &
   296            &         z_Temp(k+1), z_Press(k+1),                  &
   297            &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S),       &
   298            &         Humidity                                    &
   299            &      ),                                             &
   300            &    0.0d0                                            &
   301            &  )
   302          za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
   303          za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
   304        end if
   305  
   306      end do DtDz
   307  
   308    end subroutine ECCM_Wet
   309  
   310  !!!------------------------------------------------------------------------------!!!
   311    subroutine ECCM_MolFr( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
   312      !
   313      ! Ϳ줿٤Ф, ǮŪ˾徺˼¸
   314      ! Υץե
   315      !
   316  
   317  
   318      !ۤηػ
   319      implicit none
   320  
   321      real(DP), intent(in) :: a_MolFrIni(1:ncmax)
   322      real(DP), intent(in) :: Humidity
   323      real(DP), intent(in) :: z_Temp(kmin:kmax)
   324      real(DP), intent(in) :: z_Press(kmin:kmax)
   325      real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax)
   326  
   327      real(DP)             :: DelMolFr
   328      integer             :: k, s
   329  
   330  
   331      !-----------------------------------------------------------
   332      ! ν
   333      !-----------------------------------------------------------
   334      do s = 1, ncmax
   335        za_MolFr(:,s) = a_MolFrIni(s)
   336      end do
     .        if (ncmax .gt. 0) then                                            
     .           J1 = and(ncmax,3)                                              
     .           do s = 1, J1                                                   
     .  !CDIR       NODEP                                                       
     .              do t125 = 1, kmax + 1 - kmin                                
     .                 za_molfr(t22+t125-1,s) = a_molfrini(s)                   
     .              end do                                                      
     .           end do                                                         
     .           do s = J1 + 1, ncmax, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t125 = 1, kmax + 1 - kmin                                
     .                 za_molfr(t22+t125-1,s) = a_molfrini(s)                   
     .                 za_molfr(t22+t125-1,s+1) = a_molfrini(s+1)               
     .                 za_molfr(t22+t125-1,s+2) = a_molfrini(s+2)               
     .                 za_molfr(t22+t125-1,s+3) = a_molfrini(s+3)               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   337  
   338      !-----------------------------------------------------------
   339      ! ǮΨ dT/dz η׻.
   340      !-----------------------------------------------------------
   341      do k = 1, kmax
   342  
   343        za_MolFr(k,:) = za_MolFr(k-1,:)
     .  !CDIR NODEP                                                             
     .        do t128 = 1, ncmax                                                
     .           za_molfr(k,t128) = za_molfr(k-1,t128)                          
     .        end do                                                            
   344  
   345        !------------------------------------------------------------
   346        !NH4SH ʳβؼʿվ
   347        !------------------------------------------------------------
   348        do s = 1, CondNum
   349  
   350          !
   351          !ΥƥåפǤΥĶ뤳ȤϤʤ
   352          za_MolFr(k,IdxCG(s)) =                                 &
   353            & min(                                                &
   354            &       za_MolFr(k-1,IdxCG(s)),                      &
   355            &       SvapPress( SpcWetID(IdxCC(s)), z_Temp(k) ) &
   356            &        * Humidity / z_Press(k)                      &
   357            &      )
   358  
   359        end do
   360  
   361        !------------------------------------------------------------
   362        !NH4SH ʿվ
   363        !------------------------------------------------------------
   364        if ( IdxNH3 /= 0 ) then
   365  
   366          !Ѳ.
   367          !Ȥꤢ NH4SH Ф˰ 1.0 Ȥ(ȴ...).
   368          DelMolFr =                                            &
   369            & max (                                             &
   370            &    DelMolFrNH4SH(                                 &
   371            &      z_Temp(k), z_Press(k),                       &
   372            &      za_MolFr(k,IdxNH3), za_MolFr(k,IdxH2S), Humidity   &
   373            &     ),                                            &
   374            &    0.0d0                                          &
   375            &  )
   376  
   377          za_MolFr(k,IdxNH3) = za_MolFr(k,IdxNH3) - DelMolFr
   378          za_MolFr(k,IdxH2S) = za_MolFr(k,IdxH2S) - DelMolFr
   379        end if
   380  
   381      end do
   382    end subroutine ECCM_MolFr
   383  
   384  !!!------------------------------------------------------------------------------!!!
   385    subroutine ECCM_DTempDZ( Temp, Press, DelZ, MolFr, DTempDZ )
   386  
   387      !ۤηػ
   388      implicit none
   389  
   390      !ѿ
   391      real(DP), intent(in) :: Temp
   392      real(DP), intent(in) :: Press
   393      real(DP), intent(in) :: DelZ
   394      real(DP), intent(inout) :: MolFr(0:ncmax)    !ʬΨ
   395      real(DP), intent(out):: DTempDZ
   396      real(DP)            :: ReactHeat
   397      real(DP)            :: Heat(ncmax)
   398      real(DP)            :: DelMolFr
   399      real(DP)            :: SatPress
   400      real(DP)            :: VapPress
   401      real(DP)            :: Humidity
   402      real(DP)            :: A, B
   403      integer             :: s
   404  
   405      !
   406      DTempDZ      = 0.0d0
   407      ReactHeat    = 0.0d0
   408      Heat         = 0.0d0
   409      DelMolFr     = 0.0d0
   410      SatPress     = 0.0d0
   411      VapPress     = 0.0d0
   412  
   413      !------------------------------------------------------------
   414      !NH4SH ʳβؼʿվ
   415      !------------------------------------------------------------
   416      do s = 1, CondNum
   417  
   418        !˰¾
   419        SatPress = SvapPress( SpcWetID(IdxCC(s)), Temp )
   420  
   421        !Ǯ.
   422        Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), Temp )
   423  
   424        !ΥʬΨѤƸߤξ׻
   425        VapPress = MolFr(IdxCG(s)) * Press
   426  
   427        !˰¾ŷ̵ͭ
   428        if ( VapPress < SatPress ) then
   429          !ŷ뤷ƤʤΤǮʤ.
   430          Heat(IdxCG(s)) = 0.0d0
   431  
   432        else
   433  
   434          !˰¾ȰϤ鸽ߤΥ׻
   435          MolFr(IdxCG(s)) = max(SatPress / Press, 1.0d-16)
   436  
   437        end if
   438      end do
   439  
   440      !------------------------------------------------------------
   441      !NH4SH ʿվ
   442      !------------------------------------------------------------
   443      if ( IdxNH3 /= 0 ) then
   444  
   445        Humidity = 1.0d0
   446        DelMolFr =                                            &
   447          & max (                                             &
   448          &    DelMolFrNH4SH(                                 &
   449          &         Temp, Press, MolFr(IdxNH3), MolFr(IdxH2S),&
   450          &         Humidity                                  &
   451          &      ),                                           &
   452          &    0.0d0                                          &
   453          &  )
   454        MolFr(IdxNH3) = MolFr(IdxNH3) - DelMolFr
   455        MolFr(IdxH2S) = MolFr(IdxH2S) - DelMolFr
   456  
   457        ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
   458      end if
   459  
   460      !------------------------------------------------------------
   461      !ٸۤ׻
   462      !------------------------------------------------------------
   463      !.  Temp(i) ɾ
   464      A = dot_product( Heat(1:ncmax), MolFr(1:ncmax)) &
   465        &  / ( GasRUniv * Temp )
   466      B = dot_product(( Heat(1:ncmax) ** 2.0d0), MolFr(1:ncmax)) &
   467        &  / ( CpDryMol * GasRUniv * ( Temp ** 2.0d0 ) )
   468  
   469      !ǮٸΨ
   470      DTempDZ = - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))  &
   471        &       + ReactHeat / (CpDryMol * DelZ)
   472  
   473    end subroutine ECCM_DTempDZ
   474  
   475  !!!------------------------------------------------------------------------------!!!
   476    subroutine ECCM_Stab( xyz_PTemp, xyz_Exner, xyzf_QMix )
   477  
   478      use gridset,only: imin,       &!  X β
   479        &                 imax,       &!  X ξ
   480        &                 jmin,       &!  Y β
   481        &                 jmax,       &!  Y ξ
   482        &                 kmin,       &!  Z β
   483        &                 kmax,       &!  Z ξ
   484        &                 ncmax          !
   485      use basicset,only:  &
   486        &                 xyz_ExnerBZ,   &!
   487        &                 xyz_PTempBZ, &!
   488        &                 xyzf_QMixBZ
   489      use constants,only: MolWtDry,      &!
   490        &                 CpDry,         &!
   491        &                 Grav
   492      use composition,only:  MolWtWet
   493      use axesset, only : xyz_avr_xyr
   494      use xyz_deriv_module,only : xyr_dz_xyz
   495  
   496      implicit none
   497  
   498      real(DP), intent(in)  :: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
   499      real(DP), intent(in)  :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
   500      real(DP), intent(in)  :: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   501  
   502      real(DP) :: xyz_Stab(imin:imax,jmin:jmax,kmin:kmax)
   503      real(DP) :: xyz_StabTemp(imin:imax,jmin:jmax,kmin:kmax)
   504      real(DP) :: xyz_StabMolWt(imin:imax,jmin:jmax,kmin:kmax)
   505  
   506      real(DP)   :: xyzf_MolFrAll(imin:imax,jmin:jmax,kmin:kmax,ncmax)
   507      real(DP)   :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   508      real(DP)   :: xyz_MolWtWet(imin:imax,jmin:jmax,kmin:kmax)
   509      integer    :: i, j, k, s
   510  
   511      xyz_TempAll = (xyz_PTemp + xyz_PTempBZ) * (xyz_Exner + xyz_ExnerBZ)
     .           if (jmax + 1 - jmin .gt. 0) then                               
     .           J1 = and(jmax + 1 - jmin,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t422 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t424 = 1, imax + 1 - imin                                
     .                 xyz_tempall(xyz_tempall.DSC.L1+t424-1,t422-1+            
     .       1            xyz_tempall.DSC.L2,t420+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp(t144+t424-1,t422-1+t146,t420+t148)+         
     .       3            xyz_ptempbz(xyz_ptempbz.DSC.L1+t424-1,t422-1+         
     .       4            xyz_ptempbz.DSC.L2,t420+xyz_ptempbz.DSC.L3))*(        
     .       5            xyz_exner(t154+t424-1,t422-1+t156,t420+t158)+         
     .       6            xyz_exnerbz(xyz_exnerbz.DSC.L1+t424-1,t422-1+         
     .       7            xyz_exnerbz.DSC.L2,t420+xyz_exnerbz.DSC.L3))          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t422 = J1 + 1, jmax + 1 - jmin, 4                           
     .  !CDIR       NODEP                                                       
     .              do t424 = 1, imax + 1 - imin                                
     .                 xyz_tempall(xyz_tempall.DSC.L1+t424-1,t422-1+            
     .       1            xyz_tempall.DSC.L2,t420+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp(t144+t424-1,t422-1+t146,t420+t148)+         
     .       3            xyz_ptempbz(xyz_ptempbz.DSC.L1+t424-1,t422-1+         
     .       4            xyz_ptempbz.DSC.L2,t420+xyz_ptempbz.DSC.L3))*(        
     .       5            xyz_exner(t154+t424-1,t422-1+t156,t420+t158)+         
     .       6            xyz_exnerbz(xyz_exnerbz.DSC.L1+t424-1,t422-1+         
     .       7            xyz_exnerbz.DSC.L2,t420+xyz_exnerbz.DSC.L3))          
     .                 xyz_tempall(xyz_tempall.DSC.L1+t424-1,t422+              
     .       1            xyz_tempall.DSC.L2,t420+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp(t144+t424-1,t422+t146,t420+t148)+xyz_ptempbz
     .       3            (xyz_ptempbz.DSC.L1+t424-1,t422+xyz_ptempbz.DSC.L2,   
     .       4            t420+xyz_ptempbz.DSC.L3))*(xyz_exner(t154+t424-1,t422+
     .       5            t156,t420+t158)+xyz_exnerbz(xyz_exnerbz.DSC.L1+t424-1,
     .       6            t422+xyz_exnerbz.DSC.L2,t420+xyz_exnerbz.DSC.L3))     
     .                 xyz_tempall(xyz_tempall.DSC.L1+t424-1,t422+1+            
     .       1            xyz_tempall.DSC.L2,t420+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp(t144+t424-1,t422+1+t146,t420+t148)+         
     .       3            xyz_ptempbz(xyz_ptempbz.DSC.L1+t424-1,t422+1+         
     .       4            xyz_ptempbz.DSC.L2,t420+xyz_ptempbz.DSC.L3))*(        
     .       5            xyz_exner(t154+t424-1,t422+1+t156,t420+t158)+         
     .       6            xyz_exnerbz(xyz_exnerbz.DSC.L1+t424-1,t422+1+         
     .       7            xyz_exnerbz.DSC.L2,t420+xyz_exnerbz.DSC.L3))          
     .                 xyz_tempall(xyz_tempall.DSC.L1+t424-1,t422+2+            
     .       1            xyz_tempall.DSC.L2,t420+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp(t144+t424-1,t422+2+t146,t420+t148)+         
     .       3            xyz_ptempbz(xyz_ptempbz.DSC.L1+t424-1,t422+2+         
     .       4            xyz_ptempbz.DSC.L2,t420+xyz_ptempbz.DSC.L3))*(        
     .       5            xyz_exner(t154+t424-1,t422+2+t156,t420+t158)+         
     .       6            xyz_exnerbz(xyz_exnerbz.DSC.L1+t424-1,t422+2+         
     .       7            xyz_exnerbz.DSC.L2,t420+xyz_exnerbz.DSC.L3))          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   512      do s = 1, ncmax
   513        xyzf_MolFrAll(:,:,:,s) =                          &
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J2 = and(jmax + 1 - jmin,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t443 = 1, J2                                                
     .              D2 = molwtdry/molwtwet(s)                                   
     .  !CDIR       NODEP                                                       
     .              do t445 = 1, imax + 1 - imin                                
     .                 xyzf_molfrall(xyzf_molfrall.DSC.L1+t445-1,t443-1+        
     .       1            xyzf_molfrall.DSC.L2,t441+xyzf_molfrall.DSC.L3,s) = ( 
     .       2            xyzf_qmix(t164+t445-1,t443-1+t166,t441+t168,s)+       
     .       3            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t445-1,t443-1+         
     .       4            xyzf_qmixbz.DSC.L2,t441+xyzf_qmixbz.DSC.L3,s))*D2     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t443 = J2 + 1, jmax + 1 - jmin, 4                           
     .              D1 = molwtwet(s)                                            
     .  !CDIR       NODEP                                                       
     .              do t445 = 1, imax + 1 - imin                                
     .                 xyzf_molfrall(xyzf_molfrall.DSC.L1+t445-1,t443-1+        
     .       1            xyzf_molfrall.DSC.L2,t441+xyzf_molfrall.DSC.L3,s) = ( 
     .       2            xyzf_qmix(t164+t445-1,t443-1+t166,t441+t168,s)+       
     .       3            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t445-1,t443-1+         
     .       4            xyzf_qmixbz.DSC.L2,t441+xyzf_qmixbz.DSC.L3,s))*       
     .       5            molwtdry/D1                                           
     .                 xyzf_molfrall(xyzf_molfrall.DSC.L1+t445-1,t443+          
     .       1            xyzf_molfrall.DSC.L2,t441+xyzf_molfrall.DSC.L3,s) = ( 
     .       2            xyzf_qmix(t164+t445-1,t443+t166,t441+t168,s)+         
     .       3            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t445-1,t443+           
     .       4            xyzf_qmixbz.DSC.L2,t441+xyzf_qmixbz.DSC.L3,s))*       
     .       5            molwtdry/D1                                           
     .                 xyzf_molfrall(xyzf_molfrall.DSC.L1+t445-1,t443+1+        
     .       1            xyzf_molfrall.DSC.L2,t441+xyzf_molfrall.DSC.L3,s) = ( 
     .       2            xyzf_qmix(t164+t445-1,t443+1+t166,t441+t168,s)+       
     .       3            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t445-1,t443+1+         
     .       4            xyzf_qmixbz.DSC.L2,t441+xyzf_qmixbz.DSC.L3,s))*       
     .       5            molwtdry/D1                                           
     .                 xyzf_molfrall(xyzf_molfrall.DSC.L1+t445-1,t443+2+        
     .       1            xyzf_molfrall.DSC.L2,t441+xyzf_molfrall.DSC.L3,s) = ( 
     .       2            xyzf_qmix(t164+t445-1,t443+2+t166,t441+t168,s)+       
     .       3            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t445-1,t443+2+         
     .       4            xyzf_qmixbz.DSC.L2,t441+xyzf_qmixbz.DSC.L3,s))*       
     .       5            molwtdry/D1                                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   514          &   (xyzf_QMix(:,:,:,s) + xyzf_QMixBZ(:,:,:,s)) &
   515          &   * MolWtDry / MolWtWet(s)
   516      end do
   517  
   518      do k = kmin, kmax
   519      do j = jmin, jmax
   520      do i = imin, imax
   521        xyz_MolWtWet(i,j,k) = &
   522          &     dot_product( MolWtWet(1:GasNum), xyzf_MolFrAll(i,j,k,1:GasNum) )
   523      end do
     .        call VDMXVA (xyzf_molfrall(imin,j,k,1), 1, (xyzf_molfrall.DSC.U3  
     .       1    - xyzf_molfrall.DSC.L3 + 1)*(xyzf_molfrall.DSC.U2 -           
     .       2   xyzf_molfrall.DSC.L2 + 1)*(xyzf_molfrall.DSC.U1 -              
     .       3   xyzf_molfrall.DSC.L1 + 1), molwtwet(1), 1, xyz_molwtwet(imin,j,
     .       4   k), 1, imax + 1 - imin, gasnum)                                
   524      end do
   525      end do
   526  
   527      xyz_StabTemp =                                               &
     .        if (xyz_tempall.DSC.U2 + 1 - xyz_tempall.DSC.L2 .gt. 0) then      
     .           J3 = and(xyz_tempall.DSC.U2 + 1 - xyz_tempall.DSC.L2,3)        
     .  !CDIR    NODEP                                                          
     .           do t458 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t460 = 1, xyz_tempall.DSC.U1 + 1 - xyz_tempall.DSC.L1    
     .                 xyz_stabtemp(xyz_stabtemp.DSC.L1+t460-1,t458-1+          
     .       1            xyz_stabtemp.DSC.L2,t456+xyz_stabtemp.DSC.L3) = grav/ 
     .       2            xyz_tempall(xyz_tempall.DSC.L1+t460-1,t458-1+         
     .       3            xyz_tempall.DSC.L2,t456+xyz_tempall.DSC.L3)*(%0002fd( 
     .       4            %0002fd.DSC.L1+t460-1,t458-1+%0002fd.DSC.L2,t456+     
     .       5            %0002fd.DSC.L3)+grav/cpdry)                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t458=J3+1,xyz_tempall.DSC.U2+1-xyz_tempall.DSC.L2,4         
     .  !CDIR       NODEP                                                       
     .              do t460 = 1, xyz_tempall.DSC.U1 + 1 - xyz_tempall.DSC.L1    
     .                 xyz_stabtemp(xyz_stabtemp.DSC.L1+t460-1,t458-1+          
     .       1            xyz_stabtemp.DSC.L2,t456+xyz_stabtemp.DSC.L3) = grav/ 
     .       2            xyz_tempall(xyz_tempall.DSC.L1+t460-1,t458-1+         
     .       3            xyz_tempall.DSC.L2,t456+xyz_tempall.DSC.L3)*(%0002fd( 
     .       4            %0002fd.DSC.L1+t460-1,t458-1+%0002fd.DSC.L2,t456+     
     .       5            %0002fd.DSC.L3)+grav/cpdry)                           
     .                 xyz_stabtemp(xyz_stabtemp.DSC.L1+t460-1,t458+            
     .       1            xyz_stabtemp.DSC.L2,t456+xyz_stabtemp.DSC.L3) = grav/ 
     .       2            xyz_tempall(xyz_tempall.DSC.L1+t460-1,t458+           
     .       3            xyz_tempall.DSC.L2,t456+xyz_tempall.DSC.L3)*(%0002fd( 
     .       4            %0002fd.DSC.L1+t460-1,t458+%0002fd.DSC.L2,t456+       
     .       5            %0002fd.DSC.L3)+grav/cpdry)                           
     .                 xyz_stabtemp(xyz_stabtemp.DSC.L1+t460-1,t458+1+          
     .       1            xyz_stabtemp.DSC.L2,t456+xyz_stabtemp.DSC.L3) = grav/ 
     .       2            xyz_tempall(xyz_tempall.DSC.L1+t460-1,t458+1+         
     .       3            xyz_tempall.DSC.L2,t456+xyz_tempall.DSC.L3)*(%0002fd( 
     .       4            %0002fd.DSC.L1+t460-1,t458+1+%0002fd.DSC.L2,t456+     
     .       5            %0002fd.DSC.L3)+grav/cpdry)                           
     .                 xyz_stabtemp(xyz_stabtemp.DSC.L1+t460-1,t458+2+          
     .       1            xyz_stabtemp.DSC.L2,t456+xyz_stabtemp.DSC.L3) = grav/ 
     .       2            xyz_tempall(xyz_tempall.DSC.L1+t460-1,t458+2+         
     .       3            xyz_tempall.DSC.L2,t456+xyz_tempall.DSC.L3)*(%0002fd( 
     .       4            %0002fd.DSC.L1+t460-1,t458+2+%0002fd.DSC.L2,t456+     
     .       5            %0002fd.DSC.L3)+grav/cpdry)                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   528        &         Grav / xyz_TempAll                               &
   529        &           * (   xyz_avr_xyr( xyr_dz_xyz( xyz_TempAll ) ) &
   530        &               + Grav / CpDry )
   531      xyz_StabMolWt =                                              &
     .        if (%00031b.DSC.U2 - %00031b.DSC.L2 + 1 .gt. 0) then              
     .           J4 = and(%00031b.DSC.U2 - %00031b.DSC.L2 + 1,1)                
     .  !CDIR    NODEP                                                          
     .           do t473 = 1, J4                                                
     .              D3 = grav/molwtdry                                          
     .  !CDIR       NODEP                                                       
     .              do t475 = 1, %00031b.DSC.U1 + 1 - %00031b.DSC.L1            
     .                 xyz_stabmolwt(xyz_stabmolwt.DSC.L1+t475-1,t473-1+        
     .       1            xyz_stabmolwt.DSC.L2,t471+xyz_stabmolwt.DSC.L3) = -   
     .       2            %00031b(%00031b.DSC.L1+t475-1,t473-1+%00031b.DSC.L2,  
     .       3            t471+%00031b.DSC.L3)*D3                               
     .                 xyz_stab(xyz_stab.DSC.L1+t475-1,t473-1+xyz_stab.DSC.L2,  
     .       1            t471+xyz_stab.DSC.L3) = xyz_stabtemp(                 
     .       2            xyz_stabtemp.DSC.L1+t475-1,t473-1+xyz_stabtemp.DSC.L2,
     .       3            t471+xyz_stabtemp.DSC.L3) + xyz_stabmolwt(            
     .       4            xyz_stabmolwt.DSC.L1+t475-1,t473-1+                   
     .       5            xyz_stabmolwt.DSC.L2,t471+xyz_stabmolwt.DSC.L3)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t473 = J4 + 1, %00031b.DSC.U2 - %00031b.DSC.L2 + 1, 2       
     .              D4 = grav/molwtdry                                          
     .              D5 = grav/molwtdry                                          
     .  !CDIR       NODEP                                                       
     .              do t475 = 1, %00031b.DSC.U1 + 1 - %00031b.DSC.L1            
     .                 xyz_stabmolwt(xyz_stabmolwt.DSC.L1+t475-1,t473-1+        
     .       1            xyz_stabmolwt.DSC.L2,t471+xyz_stabmolwt.DSC.L3) = -   
     .       2            %00031b(%00031b.DSC.L1+t475-1,t473-1+%00031b.DSC.L2,  
     .       3            t471+%00031b.DSC.L3)*D4                               
     .                 xyz_stabmolwt(xyz_stabmolwt.DSC.L1+t475-1,t473+          
     .       1            xyz_stabmolwt.DSC.L2,t471+xyz_stabmolwt.DSC.L3) = -   
     .       2            %00031b(%00031b.DSC.L1+t475-1,t473+%00031b.DSC.L2,t471
     .       3            +%00031b.DSC.L3)*D5                                   
     .                 xyz_stab(xyz_stab.DSC.L1+t475-1,t473-1+xyz_stab.DSC.L2,  
     .       1            t471+xyz_stab.DSC.L3) = xyz_stabtemp(                 
     .       2            xyz_stabtemp.DSC.L1+t475-1,t473-1+xyz_stabtemp.DSC.L2,
     .       3            t471+xyz_stabtemp.DSC.L3) + xyz_stabmolwt(            
     .       4            xyz_stabmolwt.DSC.L1+t475-1,t473-1+                   
     .       5            xyz_stabmolwt.DSC.L2,t471+xyz_stabmolwt.DSC.L3)       
     .                 xyz_stab(xyz_stab.DSC.L1+t475-1,t473+xyz_stab.DSC.L2,t471
     .       1            +xyz_stab.DSC.L3) = xyz_stabtemp(xyz_stabtemp.DSC.L1+ 
     .       2            t475-1,t473+xyz_stabtemp.DSC.L2,t471+                 
     .       3            xyz_stabtemp.DSC.L3) + xyz_stabmolwt(                 
     .       4            xyz_stabmolwt.DSC.L1+t475-1,t473+xyz_stabmolwt.DSC.L2,
     .       5            t471+xyz_stabmolwt.DSC.L3)                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   532        &       - Grav * xyz_avr_xyr( xyr_dz_xyz( xyz_MolWtWet ) ) &
   533        &         / MolWtDry
   534      xyz_Stab = xyz_StabTemp + xyz_StabMolWt
   535  
   536      where (xyz_Stab < 1.0d-7)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t492 = 1, (xyz_stab.DSC.U3 + 1 - xyz_stab.DSC.L3)*(            
     .       1   xyz_stab.DSC.U2 + 1 - xyz_stab.DSC.L2)*(xyz_stab.DSC.U1 + 1 -  
     .       2   xyz_stab.DSC.L1)                                               
     .           if (xyz_stab(xyz_stab.DSC.L1+t492-1,xyz_stab.DSC.L2,           
     .       1      xyz_stab.DSC.L3) .lt. 9.99999999999999e-008) then           
     .              xyz_stab(xyz_stab.DSC.L1+t492-1,xyz_stab.DSC.L2,            
     .       1         xyz_stab.DSC.L3) = 9.99999999999999e-008                 
     .           endif                                                          
     .        end do                                                            
   537        xyz_Stab = 1.0d-7
   538      end where
   539  
   540    end subroutine ECCM_Stab
   541  
   542  end module ECCM
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:07 2011
FILE NAME: eccm.f90
PROGRAM NAME: eccm
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module ECCM
     2:            !
     3:            ! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: eccm.f90,v 1.5 2011-06-03 06:11:22 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            !ǮŪ˾徺뵤βٸΨ׻, ſ尵ʿդ鰵Ϥ
    12:            !
    13:            !== Error Handling
    14:            !
    15:            !== Known Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !  * Ǯ, ʿʬ̤
    20:            !  * 顼٤­ʤΤ, 󥲥å. 
    21:            !
    22:            !== Future Plans
    23:            !
    24:            
    25:            module ECCM
    26:            
    27:              !⥸塼ɤ߹
    28:              use dc_types, only : DP
    29:              use dc_trace, only : DbgMessage
    30:              use dc_message, only: MessageNotify
    31:            
    32:              use gridset,only: kmin,       &!  Z β
    33:                &                 kmax,       &!  Z ξ 
    34:                &                 ncmax
    35:              use axesset, only:  z_dz, r_dz      !
    36:              use constants,only: MolWtDry,      &!
    37:                &                 CpDryMol,      &!
    38:                &                 TempSfc,       &!
    39:                &                 PressSfc,      &!
    40:                &                 Grav            !
    41:              use chemcalc, only: SvapPress,        &!
    42:                &                 LatentHeatPerMol, &!
    43:                &                 ReactHeatNH4SHPerMol, &
    44:                &                 DelMolFrNH4SH 
    45:              use composition, only: CondNum,          &!ŷο
    46:                &                 SpcWetID,         &!
    47:                &                 IdxCG,            &!ŷ()ź
    48:                &                 IdxCC,            &!ŷ()ź
    49:                &                 GasNum,           &!Το
    50:                &                 IdxNH3,           &!NH3()ź
    51:                &                 IdxH2S             !H2S()ź
    52:              use ChemData, only: GasRUniv        
    53:            
    54:              !ۤηػ
    55:              implicit none
    56:            
    57:              !°λ
    58:              private
    59:            
    60:              !ؿθ
    61:              public ECCM_MolFr
    62:              public ECCM_Stab
    63:              public ECCM_Dry
    64:              public ECCM_Wet
    65:            
    66:            contains
    67:            
    68:            !!!------------------------------------------------------------------------------!!!
    69:              subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    70:                !
    71:                !== 
    72:                !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    73:                !  * Ǯϴ絤ΤΤɽ
    74:                !    * ήΤˤǮϴʬΤΤɽƤ뤿
    75:                !  * 絤ʿʬ̤ˤϼʬʬ̤
    76:                !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    77:                !
    78:                
    79:                !ۤηػ
    80:                implicit none
    81:                
    82:                real(DP), intent(in) :: a_MolFrIni(1:ncmax)    !ǤΥ
    83:                real(DP), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    84:                real(DP), intent(out):: z_Temp(kmin:kmax) !
    85:                real(DP), intent(out):: z_Press(kmin:kmax)!
    86:                real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax) 
    87:                                                               !ʬΨ
    88:                real(DP)             :: SatPress                !˰¾
    89:                real(DP)             :: VapPress                !
    90:                real(DP)             :: DelMolFr
    91:                integer             :: k, s
    92:            
    93:                !-------------------------------------------------------------
    94:                ! ν
    95:                !-------------------------------------------------------------
    96:                !ɽ̤ʬ̤
    97: W+=====        za_MolFr  = 1.0d-60
    98: V======        za_MolFr(1, 1:ncmax) = a_MolFrIni(1:ncmax) 
    99:            
   100:                !ɽ̤Ǥβ(nx ,  DelZ / 2 )
   101: V======        z_Temp    = 1.0d-60
   102:                z_Temp(1) = TempSfc - Grav * MolWtDry &
   103:                  &               / CpDryMol * ( z_dz(1) * 5.0d-1 )
   104:            
   105:            !    write(*,*) z_Temp(1)
   106:                
   107:                !ɽ̤Ǥΰ(1 ,  DelZ / 2 )
   108: V======        z_Press    = 1.0d-60
   109:                z_Press(1) = PressSfc *((TempSfc / z_Temp(1)) ** (- CpDryMol /  GasRUniv))
   110:            
   111:            !    write(*,*) z_Press(1)
   112:                
   113:                !-----------------------------------------------------------
   114:                ! (1) Ǯ˱ä٤
   115:                ! (2) ſ尵ʿդ鰵Ϥ
   116:                ! (3) (1),(2) βٰϤФ, Ȥм٤Ȥʤ
   117:                !-----------------------------------------------------------    
   118: +------>       DtDz: do k = 1, kmax-1
   119: |          
   120: |                !(1)Ǯ˱ä k+1 Ǥβ٤׻
   121: |                z_Temp(k+1) = z_Temp(k) - Grav * MolWtDry / CpDryMol * r_dz(k)
   122: |                
   123: |                !ǰ
   124: |                if (z_Temp(k+1) <= 0.0d0 ) z_Temp(k+1) = z_Temp(k) 
   125: |                
   126: |                !(2)Ϥſ尵ʿդ׻
   127: |                z_Press(k+1) =                                                  &
   128: |                  &  z_Press(k) * ((z_Temp(k) / z_Temp(k+1)) ** (- CpDryMol / GasRUniv)) 
   129: |          
   130: |                !(3)η׻
   131: |                !  ޤϥѲʤΤȤƥͿ
   132: |                !  ˰¾ʿȤʿվŬѤƤ
   133: |V=====          za_MolFr(k+1,:) = za_MolFr(k,:)
   134: |                
   135: |+----->         do s = 1, CondNum      
   136: ||                 !˰¾
   137: ||                 SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )        
   138: ||                 
   139: ||                 !ΥʬΨѤƸߤξ׻
   140: ||                 VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
   141: ||                 
   142: ||                 !˰¾ȰϤ鸽ߤΥ׻
   143: ||                 if ( VapPress > SatPress ) then         
   144: ||                   za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)
   145: ||                 end if
   146: |+-----          end do
   147: |                
   148: |                !NH4SH ʿվ
   149: |                if ( IdxNH3 /= 0 ) then 
   150: |                  DelMolFr =                                              &
   151: |                    & max (                                               &
   152: |                    &    DelMolFrNH4SH(                                   &
   153: |                    &         z_Temp(k+1), z_Press(k+1),                  &
   154: |                    &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S), &
   155: |                    &         Humidity                                    &
   156: |                    &      ),                                             &
   157: |                    &    0.0d0                                            &
   158: |                    &  )
   159: |                  za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
   160: |                  za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
   161: |                end if
   162: |                
   163: +------        end do DtDz
   164:                
   165:              end subroutine ECCM_Dry
   166:            
   167:            
   168:            !!------------------------------------------------------------------------------!!!
   169:              subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
   170:                !
   171:                !== 
   172:                !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
   173:                !  * Ǯϴ絤ΤΤɽ
   174:                !    * ήΤˤǮϴʬΤΤɽƤ뤿
   175:                !  * 絤ʿʬ̤ˤϼʬʬ̤
   176:                !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
   177:                !
   178:                
   179:                !ۤηػ
   180:                implicit none
   181:                
   182:                real(DP), intent(in) :: a_MolFrIni(1:ncmax)    !ǤΥ
   183:                real(DP), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
   184:                real(DP), intent(out):: z_Temp(kmin:kmax) !
   185:                real(DP), intent(out):: z_Press(kmin:kmax)!
   186:                                                               !ʿʬ
   187:                real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax) 
   188:                                                               !ʬΨ
   189:                real(DP)             :: SatPress                !˰¾
   190:                real(DP)             :: VapPress                !
   191:                real(DP)             :: DelMolFr
   192:                real(DP)             :: a_MolFr(ncmax)         !κ
   193:                integer             :: k, s
   194:            
   195:                real(DP)             :: Temp1, Press1, DTempDZ1
   196:                real(DP)             :: Temp2, Press2, DTempDZ2
   197:                real(DP)             :: Temp3, Press3, DTempDZ3
   198:                real(DP)             :: Temp4, Press4, DTempDZ4
   199:                real(DP)             :: DTempDZ
   200:                
   201:                !-------------------------------------------------------------
   202:                ! ν
   203:                !-------------------------------------------------------------
   204:                !ɽ̤ʬ̤
   205: W+=====        za_MolFr  = 1.0d-60
   206: V======        za_MolFr(1, 1:ncmax)   = a_MolFrIni(1:ncmax) 
   207:                
   208:                !ɽ̤Ǥβ(1 ,  DelZ / 2 )
   209: V======        z_Temp          = 1.0d-60
   210:                z_Temp(1) = TempSfc - Grav * MolWtDry  &
   211:                  &               / CpDryMol * ( z_dz(1) * 5.0d-1 )
   212:                
   213:                !ɽ̤Ǥΰ(1 ,  DelZ / 2 )
   214: V======        z_Press           = 1.0d-60
   215:                z_Press(1)  = &
   216:                  & PressSfc *((TempSfc / z_Temp(1)) ** (- CpDryMol /  GasRUniv))
   217:                
   218:                !-----------------------------------------------------------
   219:                ! ǮΨ dT/dz η׻. 
   220:                !-----------------------------------------------------------    
   221: +------>       DtDz: do k = 1, kmax-1
   222: |                
   223: |                !
   224: |V=====          za_MolFr(k+1,:) = za_MolFr(k,:)
   225: |                
   226: |                !----------------------------------------------------
   227: |                !ǮΨ󥲥åˡѤƷ׻
   228: |                !----------------------------------------------------
   229: |                ! (0)  k Ǥͤݴ
   230: |                Temp1  = z_Temp(k)
   231: |                Press1 = z_Press(k)
   232: |V=====          a_MolFr  = za_MolFr(k,:)
   233: |          
   234: |                ! (1)  k ǤͤѤƲѲ׻
   235: |                call ECCM_DTempDZ( Temp1, Press1, r_dz(k), a_MolFr, DTempDZ1 )
   236: |          
   237: |                ! (2) (1) ǵ᤿ͤѤ,  k + k/2 ǤͤѤƲѲ׻
   238: |                !     ΤȤ, ʬ̤ѲʤΤȤ.
   239: |                Temp2  = Temp1 + DTempDZ1 * r_dz(k) * 5.0d-1
   240: |                Press2 =                                     &
   241: |                  & Press1 * ((Temp1 / Temp3) ** (Grav * MolWtDry / (GasRUniv * DTempDZ2))) 
   242: |                call ECCM_DTempDZ( Temp2, Press2, r_dz(k), a_MolFr, DTempDZ2 )
   243: |          
   244: |                ! (3) (2) ǵ᤿ͤѤ,  k + k/2 ǤͤѤƲѲ׻
   245: |                !     ΤȤ, ʬ̤ѲʤΤȤ.
   246: |                Temp3  = Temp1 + DTempDZ2 * r_dz(k) * 5.0d-1
   247: |                Press3 =                                                                   &
   248: |                  & Press1 * ((Temp1 / Temp3) ** (Grav * MolWtDry / (GasRUniv * DTempDZ2)))
   249: |                call ECCM_DTempDZ( Temp3, Press3, r_dz(k), a_MolFr, DTempDZ3 )
   250: |                
   251: |                ! (4) (3) ǵ᤿ͤѤ,  k + k ǤͤѤƲѲ׻
   252: |                !     ΤȤ, ʬ̤ѲʤΤȤ.
   253: |                Temp4  = Temp1 + DTempDZ3 * r_dz(k)
   254: |                Press4 =                                               &
   255: |                  & Press1 * ((Temp1 / Temp4) ** (Grav * MolWtDry / (GasRUniv * DTempDZ3)))
   256: |                call ECCM_DTempDZ( Temp4, Press4, r_dz(k), a_MolFr, DTempDZ4 )
   257: |                
   258: |                ! (5) ǽŪʷ
   259: |                DTempDZ = (DTempDZ1 + DTempDZ2 * 2.0d0 + DTempDZ3 * 2.0d0 + DTempDZ4) / 6.0d0
   260: |          
   261: |                !----------------------------------------------------
   262: |                !줿ٸΨ겹٤ȰϤ
   263: |                !----------------------------------------------------
   264: |                !٤׻
   265: |                z_Temp(k+1) = z_Temp(k) + DTempDz * r_dz(k)
   266: |          
   267: |                !ǰ
   268: |                if(z_Temp(k+1) < 0.0d0) z_Temp(k+1) = z_Temp(k) 
   269: |                
   270: |                !Ϥſ尵ʿդ׻
   271: |                z_Press(k+1) =                                                  &
   272: |                  &  z_Press(k) * ( ( z_Temp(k) / z_Temp(k+1))                  &
   273: |                  &    ** (Grav * MolWtDry / ( DTempDZ * GasRUniv ) ) )
   274: |                
   275: |                !----------------------------------------------------
   276: |                !η׻
   277: |                !----------------------------------------------------
   278: |+----->         do s = 1, CondNum      
   279: ||                 !˰¾
   280: ||                 SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )
   281: ||                 
   282: ||                 !ΥʬΨѤƸߤξ׻
   283: ||                 VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
   284: ||                 
   285: ||                 !˰¾ȰϤ鸽ߤΥ׻
   286: ||                 if ( VapPress > SatPress ) then         
   287: ||                   za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)
   288: ||                 end if
   289: |+-----          end do
   290: |                
   291: |                !NH4SH ʿվ
   292: |                if ( IdxNH3 /= 0 ) then 
   293: |                  DelMolFr =                                              &
   294: |                    & max (                                               &
   295: |                    &    DelMolFrNH4SH(                                   &
   296: |                    &         z_Temp(k+1), z_Press(k+1),                  &
   297: |                    &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S),       &
   298: |                    &         Humidity                                    &
   299: |                    &      ),                                             &
   300: |                    &    0.0d0                                            &
   301: |                    &  )
   302: |                  za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
   303: |                  za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
   304: |                end if
   305: |                
   306: +------        end do DtDz
   307:                
   308:              end subroutine ECCM_Wet
   309:            
   310:            !!!------------------------------------------------------------------------------!!!
   311:              subroutine ECCM_MolFr( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
   312:                !
   313:                ! Ϳ줿٤Ф, ǮŪ˾徺˼¸
   314:                ! Υץե
   315:                !
   316:            
   317:                
   318:                !ۤηػ
   319:                implicit none
   320:                
   321:                real(DP), intent(in) :: a_MolFrIni(1:ncmax)
   322:                real(DP), intent(in) :: Humidity
   323:                real(DP), intent(in) :: z_Temp(kmin:kmax)
   324:                real(DP), intent(in) :: z_Press(kmin:kmax)
   325:                real(DP), intent(out):: za_MolFr(kmin:kmax, 1:ncmax)
   326:                
   327:                real(DP)             :: DelMolFr
   328:                integer             :: k, s
   329:                
   330:            
   331:                !-----------------------------------------------------------
   332:                ! ν
   333:                !-----------------------------------------------------------
   334: +------>       do s = 1, ncmax
   335: |V=====          za_MolFr(:,s) = a_MolFrIni(s) 
   336: +------        end do
   337:            
   338:                !-----------------------------------------------------------
   339:                ! ǮΨ dT/dz η׻. 
   340:                !-----------------------------------------------------------
   341: +------>       do k = 1, kmax
   342: |          
   343: |V=====          za_MolFr(k,:) = za_MolFr(k-1,:)
   344: |                
   345: |                !------------------------------------------------------------
   346: |                !NH4SH ʳβؼʿվ
   347: |                !------------------------------------------------------------
   348: |+----->         do s = 1, CondNum
   349: ||         
   350: ||                 !
   351: ||                 !ΥƥåפǤΥĶ뤳ȤϤʤ
   352: ||                 za_MolFr(k,IdxCG(s)) =                                 &
   353: ||                   & min(                                                &
   354: ||                   &       za_MolFr(k-1,IdxCG(s)),                      &
   355: ||                   &       SvapPress( SpcWetID(IdxCC(s)), z_Temp(k) ) &
   356: ||                   &        * Humidity / z_Press(k)                      &
   357: ||                   &      )
   358: ||                 
   359: |+-----          end do
   360: |          
   361: |                !------------------------------------------------------------
   362: |                !NH4SH ʿվ
   363: |                !------------------------------------------------------------
   364: |                if ( IdxNH3 /= 0 ) then 
   365: |                  
   366: |                  !Ѳ. 
   367: |                  !Ȥꤢ NH4SH Ф˰ 1.0 Ȥ(ȴ...).
   368: |                  DelMolFr =                                            &
   369: |                    & max (                                             &
   370: |                    &    DelMolFrNH4SH(                                 &
   371: |                    &      z_Temp(k), z_Press(k),                       &
   372: |                    &      za_MolFr(k,IdxNH3), za_MolFr(k,IdxH2S), Humidity   &
   373: |                    &     ),                                            &
   374: |                    &    0.0d0                                          &
   375: |                    &  )
   376: |                  
   377: |                  za_MolFr(k,IdxNH3) = za_MolFr(k,IdxNH3) - DelMolFr 
   378: |                  za_MolFr(k,IdxH2S) = za_MolFr(k,IdxH2S) - DelMolFr
   379: |                end if
   380: |                
   381: +------        end do
   382:              end subroutine ECCM_MolFr
   383:            
   384:            !!!------------------------------------------------------------------------------!!!
   385:              subroutine ECCM_DTempDZ( Temp, Press, DelZ, MolFr, DTempDZ )
   386:                
   387:                !ۤηػ
   388:                implicit none
   389:                
   390:                !ѿ
   391:                real(DP), intent(in) :: Temp
   392:                real(DP), intent(in) :: Press
   393:                real(DP), intent(in) :: DelZ
   394:                real(DP), intent(inout) :: MolFr(0:ncmax)    !ʬΨ
   395:                real(DP), intent(out):: DTempDZ
   396:                real(DP)            :: ReactHeat
   397:                real(DP)            :: Heat(ncmax)
   398:                real(DP)            :: DelMolFr
   399:                real(DP)            :: SatPress
   400:                real(DP)            :: VapPress
   401:                real(DP)            :: Humidity
   402:                real(DP)            :: A, B
   403:                integer             :: s
   404:            
   405:                !
   406:                DTempDZ      = 0.0d0
   407:                ReactHeat    = 0.0d0
   408: V======        Heat         = 0.0d0
   409:                DelMolFr     = 0.0d0
   410:                SatPress     = 0.0d0
   411:                VapPress     = 0.0d0
   412:            
   413:                !------------------------------------------------------------
   414:                !NH4SH ʳβؼʿվ
   415:                !------------------------------------------------------------
   416: +------>       do s = 1, CondNum      
   417: |                
   418: |                !˰¾
   419: |                SatPress = SvapPress( SpcWetID(IdxCC(s)), Temp )
   420: |                
   421: |                !Ǯ. 
   422: |                Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), Temp )
   423: |                
   424: |                !ΥʬΨѤƸߤξ׻
   425: |                VapPress = MolFr(IdxCG(s)) * Press
   426: |                
   427: |                !˰¾ŷ̵ͭ
   428: |                if ( VapPress < SatPress ) then         
   429: |                  !ŷ뤷ƤʤΤǮʤ.
   430: |                  Heat(IdxCG(s)) = 0.0d0          
   431: |          
   432: |                else      
   433: |          
   434: |                  !˰¾ȰϤ鸽ߤΥ׻
   435: |                  MolFr(IdxCG(s)) = max(SatPress / Press, 1.0d-16)
   436: |          
   437: |                end if
   438: +------        end do
   439:                
   440:                !------------------------------------------------------------
   441:                !NH4SH ʿվ
   442:                !------------------------------------------------------------
   443:                if ( IdxNH3 /= 0 ) then 
   444:                  
   445:                  Humidity = 1.0d0
   446:                  DelMolFr =                                            &
   447:                    & max (                                             &
   448:                    &    DelMolFrNH4SH(                                 &
   449:                    &         Temp, Press, MolFr(IdxNH3), MolFr(IdxH2S),&
   450:                    &         Humidity                                  &
   451:                    &      ),                                           &
   452:                    &    0.0d0                                          &
   453:                    &  )
   454:                  MolFr(IdxNH3) = MolFr(IdxNH3) - DelMolFr
   455:                  MolFr(IdxH2S) = MolFr(IdxH2S) - DelMolFr
   456:            
   457:                  ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
   458:                end if
   459:                
   460:                !------------------------------------------------------------
   461:                !ٸۤ׻
   462:                !------------------------------------------------------------
   463:                !.  Temp(i) ɾ
   464: V======        A = dot_product( Heat(1:ncmax), MolFr(1:ncmax)) &
   465:                  &  / ( GasRUniv * Temp )
   466: V======        B = dot_product(( Heat(1:ncmax) ** 2.0d0), MolFr(1:ncmax)) &
   467:                  &  / ( CpDryMol * GasRUniv * ( Temp ** 2.0d0 ) )
   468:                
   469:                !ǮٸΨ
   470:                DTempDZ = - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))  &
   471:                  &       + ReactHeat / (CpDryMol * DelZ)
   472:                
   473:              end subroutine ECCM_DTempDZ
   474:            
   475:            !!!------------------------------------------------------------------------------!!!
   476:              subroutine ECCM_Stab( xyz_PTemp, xyz_Exner, xyzf_QMix )
   477:            
   478:                use gridset,only: imin,       &!  X β
   479:                  &                 imax,       &!  X ξ 
   480:                  &                 jmin,       &!  Y β
   481:                  &                 jmax,       &!  Y ξ 
   482:                  &                 kmin,       &!  Z β
   483:                  &                 kmax,       &!  Z ξ 
   484:                  &                 ncmax          !
   485:                use basicset,only:  &
   486:                  &                 xyz_ExnerBZ,   &!
   487:                  &                 xyz_PTempBZ, &! 
   488:                  &                 xyzf_QMixBZ
   489:                use constants,only: MolWtDry,      &!
   490:                  &                 CpDry,         &!
   491:                  &                 Grav          
   492:                use composition,only:  MolWtWet
   493:                use axesset, only : xyz_avr_xyr
   494:                use xyz_deriv_module,only : xyr_dz_xyz
   495:                
   496:                implicit none
   497:            
   498:                real(DP), intent(in)  :: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
   499:                real(DP), intent(in)  :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
   500:                real(DP), intent(in)  :: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   501:            
   502:                real(DP) :: xyz_Stab(imin:imax,jmin:jmax,kmin:kmax)
   503:                real(DP) :: xyz_StabTemp(imin:imax,jmin:jmax,kmin:kmax)
   504:                real(DP) :: xyz_StabMolWt(imin:imax,jmin:jmax,kmin:kmax)
   505:            
   506:                real(DP)   :: xyzf_MolFrAll(imin:imax,jmin:jmax,kmin:kmax,ncmax)
   507:                real(DP)   :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   508:                real(DP)   :: xyz_MolWtWet(imin:imax,jmin:jmax,kmin:kmax)
   509:                integer    :: i, j, k, s
   510:            
   511: ++V====        xyz_TempAll = (xyz_PTemp + xyz_PTempBZ) * (xyz_Exner + xyz_ExnerBZ)
   512: +------>       do s = 1, ncmax
   513: |++V===          xyzf_MolFrAll(:,:,:,s) =                          &
   514: |                  &   (xyzf_QMix(:,:,:,s) + xyzf_QMixBZ(:,:,:,s)) &
   515: |                  &   * MolWtDry / MolWtWet(s) 
   516: +------        end do
   517:                
   518: +------>       do k = kmin, kmax
   519: |+----->       do j = jmin, jmax
   520: ||V---->       do i = imin, imax
   521: |||+===          xyz_MolWtWet(i,j,k) = &
   522: |||                &     dot_product( MolWtWet(1:GasNum), xyzf_MolFrAll(i,j,k,1:GasNum) )
   523: ||V----        end do
   524: |+-----        end do
   525: +------        end do
   526:                
   527: ++V====        xyz_StabTemp =                                               &
   528:                  &         Grav / xyz_TempAll                               &
   529:                  &           * (   xyz_avr_xyr( xyr_dz_xyz( xyz_TempAll ) ) &
   530:                  &               + Grav / CpDry ) 
   531: **V---->       xyz_StabMolWt =                                              &
   532: |||              &       - Grav * xyz_avr_xyr( xyr_dz_xyz( xyz_MolWtWet ) ) &
   533: |||              &         / MolWtDry 
   534: **V----        xyz_Stab = xyz_StabTemp + xyz_StabMolWt
   535:            
   536: **W---->       where (xyz_Stab < 1.0d-7) 
   537: **W----          xyz_Stab = 1.0d-7
   538:                end where
   539:            
   540:              end subroutine ECCM_Stab
   541:            
   542:            end module ECCM
