Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:25 2011
FILE NAME: timeset.f90
PROGRAM NAME: timeset
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module TimeSet
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4  ! Version::   $Id: timeset.f90,v 1.7 2011-07-15 08:43:29 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !Ϳ줿 NAMELIST ե뤫, ˴ؤ,
    12  !ݴɤ뤿ѿ⥸塼
    13  !
    14  !== Error Handling
    15  !
    16  !== Known Bugs
    17  !
    18  !== Note
    19  !
    20  !== Future Plans
    21  !
    22  !
    23  
    24  module timeset
    25    !
    26    !Ϳ줿 NAMELIST ե뤫, ˴ؤ,
    27    !ݴɤ뤿ѿ⥸塼
    28    !
    29  
    30    !⥸塼ɤ߹
    31    use dc_types,   only: DP, STRING
    32    use dc_iounit,  only: FileOpen
    33    use dc_message, only: MessageNotify
    34    use mpi_wrapper, only: myrank
    35    use namelist_util, only: namelist_filename
    36  
    37    !ۤηػ
    38    implicit none
    39  
    40    !°
    41    private
    42  
    43    ! Public Interface
    44    real(DP), save, public  :: TimeA                   ! t + \del t
    45    real(DP), save, public  :: TimeN                   ! t
    46    real(DP), save, public  :: TimeB                   ! t - \del t
    47    real(DP), save, public  :: DelTimeLong  = 2.0d0    !Ĺॹƥå
    48    real(DP), save, public  :: DelTimeLongSave  = 2.0d0 !Ĺॹƥå
    49    real(DP), save, public  :: DelTimeShort = 2.0d-1   !ûॹƥå
    50    real(DP), save, public  :: RestartTime  = 0.0d0    !׻ϻ
    51    real(DP), save, public  :: IntegPeriod  = 3600.0d0 !ʬ
    52    real(DP), save, public  :: EndTime      = 3600.0d0 !׻λ
    53    real(DP), save, public  :: DelTimeOutput= 2.0d0    !ϥॹƥå
    54    integer,  save, public  :: NstepShort = 20         !ûॹƥåפΥƥå׿
    55    integer,  save, public  :: NstepShortSave = 20     !ûॹƥåפΥƥå׿
    56    integer,  save, public  :: NstepOutput    = 20     !ꥹȥեؤν
    57  
    58    ! 
    59    public timeset_init, TimesetProgress
    60  
    61  contains
    62  
    63    subroutine timeset_init()
    64      !
    65      !NAMELIST ɬפʾɤ߼, ִϢѿԤ.
    66      !
    67  
    68      !ۤηػ
    69      implicit none
    70  
    71      !ѿ
    72      integer    :: unit
    73  
    74      !---------------------------------------------------------------
    75      ! NAMELIST 
    76      !
    77      NAMELIST /timeset_nml/ &
    78        & DelTimeLong, DelTimeShort, IntegPeriod, RestartTime, DelTimeOutput
    79  
    80      call FileOpen(unit, file=namelist_filename, mode='r')
    81      read(unit, NML=timeset_nml)
    82      close(unit)
    83  
    84      ! ׻λ
    85      !
    86      EndTime = RestartTime + IntegPeriod
    87  
    88      ! ॹƥåפ
    89      !   t=0 λ, ǽ 1 롼פ顼ˡǲ򤯤ΤǺٹ.
    90      !
    91      NstepShort = 2 * nint( DelTimeLong / DelTimeShort )
    92  
    93      DelTimeLongSave = DelTimeLong
    94      NstepShortSave  = NstepShort
    95  
    96      NstepOutput = nint( DelTimeOutput / DelTimeLong )
    97  
    98      if (RestartTime /= 0.0d0) then
    99        TimeB = RestartTime - DelTimeLong
   100        TimeN = RestartTime
   101        TimeA = RestartTime + DelTimeLong
   102      else
   103        TimeB = RestartTime
   104        TimeN = RestartTime
   105        TimeA = RestartTime + DelTimeLong
   106        DelTimeLong = DelTimeLong * 5.0d-1
   107        NstepShort = NstepShort / 2
   108      end if
   109  
   110      !---------------------------------------------------------------
   111      ! ǧ
   112      !
   113      if (myrank == 0) then
   114  
   115        !Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
   116        if(mod(DelTimeLong, DelTimeShort) /= 0) then
   117          call MessageNotify( "W", &
   118            & "timeset_init", "mod(DelTimeLong, DelTimeShort) is not zero")
   119        end if
   120  
   121        !Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
   122        if(mod(DelTimeOutput, DelTimeLong) /= 0) then
   123          call MessageNotify( "W", &
   124            & "timeset_init", "mod(DelTimeOutput, DelTimeLong) is not zero")
   125        end if
   126  
   127        call MessageNotify( "M", &
   128          & "timeset_init", "DelTimeLong  = %f", d=(/DelTimeLongSave/) )
   129        call MessageNotify( "M", &
   130          & "timeset_init", "DelTimeShort = %f", d=(/DelTimeShort/) )
   131        call MessageNotify( "M", &
   132          & "timeset_init", "Restarttime  = %f", d=(/Restarttime/)  )
   133        call MessageNotify( "M", &
   134          & "timeset_init", "IntegPeriod  = %f", d=(/IntegPeriod/) )
   135        call MessageNotify( "M", &
   136          & "timeset_init", "EndTime      = %f", d=(/EndTime/) )
   137        call MessageNotify( "M", &
   138          & "timeset_init", "DelTimeOutput= %f", d=(/DelTimeOutput/) )
   139        call MessageNotify( "M", &
   140          & "timeset_init", "NstepShort   = %d", i=(/NstepShort/) )
   141        call MessageNotify( "M", &
   142          & "timeset_init", "NstepOutput  = %d", i=(/NstepOutput/) )
   143      end if
   144  
   145    end subroutine timeset_init
   146  
   147  
   148    subroutine TimesetProgress
   149  
   150      implicit none
   151  
   152      ! ľ
   153      !
   154      DelTimeLong = DelTimeLongSave
   155      NstepShort  = NstepShortSave
   156  
   157      ! ʤ
   158      !
   159      TimeB = TimeN
   160      TimeN = TimeA
   161      TimeA = TimeA + DelTimeLong
   162  
   163    end subroutine TimesetProgress
   164  
   165  end module timeset
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:25 2011
FILE NAME: timeset.f90
PROGRAM NAME: timeset
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module TimeSet
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: timeset.f90,v 1.7 2011-07-15 08:43:29 sugiyama Exp $ 
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            !Ϳ줿 NAMELIST ե뤫, ˴ؤ, 
    12:            !ݴɤ뤿ѿ⥸塼
    13:            !
    14:            !== Error Handling
    15:            !
    16:            !== Known Bugs
    17:            !
    18:            !== Note
    19:            !
    20:            !== Future Plans
    21:            !
    22:            !
    23:            
    24:            module timeset
    25:              !
    26:              !Ϳ줿 NAMELIST ե뤫, ˴ؤ, 
    27:              !ݴɤ뤿ѿ⥸塼
    28:              !
    29:              
    30:              !⥸塼ɤ߹
    31:              use dc_types,   only: DP, STRING
    32:              use dc_iounit,  only: FileOpen
    33:              use dc_message, only: MessageNotify
    34:              use mpi_wrapper, only: myrank
    35:              use namelist_util, only: namelist_filename
    36:              
    37:              !ۤηػ
    38:              implicit none
    39:            
    40:              !°
    41:              private
    42:              
    43:              ! Public Interface
    44:              real(DP), save, public  :: TimeA                   ! t + \del t
    45:              real(DP), save, public  :: TimeN                   ! t
    46:              real(DP), save, public  :: TimeB                   ! t - \del t
    47:              real(DP), save, public  :: DelTimeLong  = 2.0d0    !Ĺॹƥå
    48:              real(DP), save, public  :: DelTimeLongSave  = 2.0d0 !Ĺॹƥå
    49:              real(DP), save, public  :: DelTimeShort = 2.0d-1   !ûॹƥå
    50:              real(DP), save, public  :: RestartTime  = 0.0d0    !׻ϻ
    51:              real(DP), save, public  :: IntegPeriod  = 3600.0d0 !ʬ
    52:              real(DP), save, public  :: EndTime      = 3600.0d0 !׻λ
    53:              real(DP), save, public  :: DelTimeOutput= 2.0d0    !ϥॹƥå
    54:              integer,  save, public  :: NstepShort = 20         !ûॹƥåפΥƥå׿
    55:              integer,  save, public  :: NstepShortSave = 20     !ûॹƥåפΥƥå׿
    56:              integer,  save, public  :: NstepOutput    = 20     !ꥹȥեؤν
    57:              
    58:              ! 
    59:              public timeset_init, TimesetProgress
    60:            
    61:            contains
    62:               
    63:              subroutine timeset_init()
    64:                !
    65:                !NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
    66:                !
    67:            
    68:                !ۤηػ
    69:                implicit none
    70:            
    71:                !ѿ
    72:                integer    :: unit
    73:            
    74:                !---------------------------------------------------------------    
    75:                ! NAMELIST 
    76:                !
    77:                NAMELIST /timeset_nml/ &
    78:                  & DelTimeLong, DelTimeShort, IntegPeriod, RestartTime, DelTimeOutput
    79:                
    80:                call FileOpen(unit, file=namelist_filename, mode='r')
    81:                read(unit, NML=timeset_nml)
    82:                close(unit)
    83:            
    84:                ! ׻λ
    85:                !
    86:                EndTime = RestartTime + IntegPeriod
    87:                
    88:                ! ॹƥåפ
    89:                !   t=0 λ, ǽ 1 롼פ顼ˡǲ򤯤ΤǺٹ. 
    90:                !    
    91:                NstepShort = 2 * nint( DelTimeLong / DelTimeShort )
    92:            
    93:                DelTimeLongSave = DelTimeLong
    94:                NstepShortSave  = NstepShort
    95:            
    96:                NstepOutput = nint( DelTimeOutput / DelTimeLong )
    97:            
    98:                if (RestartTime /= 0.0d0) then 
    99:                  TimeB = RestartTime - DelTimeLong
   100:                  TimeN = RestartTime
   101:                  TimeA = RestartTime + DelTimeLong      
   102:                else
   103:                  TimeB = RestartTime
   104:                  TimeN = RestartTime
   105:                  TimeA = RestartTime + DelTimeLong
   106:                  DelTimeLong = DelTimeLong * 5.0d-1
   107:                  NstepShort = NstepShort / 2
   108:                end if
   109:            
   110:                !---------------------------------------------------------------
   111:                ! ǧ
   112:                !
   113:                if (myrank == 0) then
   114:                
   115:                  !Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
   116:                  if(mod(DelTimeLong, DelTimeShort) /= 0) then 
   117:                    call MessageNotify( "W", &
   118:                      & "timeset_init", "mod(DelTimeLong, DelTimeShort) is not zero")
   119:                  end if
   120:            
   121:                  !Ĺ֥ƥåפû֥ƥåפǳڤʤˤϷٹФ
   122:                  if(mod(DelTimeOutput, DelTimeLong) /= 0) then 
   123:                    call MessageNotify( "W", &
   124:                      & "timeset_init", "mod(DelTimeOutput, DelTimeLong) is not zero")
   125:                  end if
   126:                  
   127:                  call MessageNotify( "M", &
   128:                    & "timeset_init", "DelTimeLong  = %f", d=(/DelTimeLongSave/) )
   129:                  call MessageNotify( "M", &
   130:                    & "timeset_init", "DelTimeShort = %f", d=(/DelTimeShort/) )
   131:                  call MessageNotify( "M", &
   132:                    & "timeset_init", "Restarttime  = %f", d=(/Restarttime/)  )
   133:                  call MessageNotify( "M", &
   134:                    & "timeset_init", "IntegPeriod  = %f", d=(/IntegPeriod/) )
   135:                  call MessageNotify( "M", &
   136:                    & "timeset_init", "EndTime      = %f", d=(/EndTime/) )
   137:                  call MessageNotify( "M", &
   138:                    & "timeset_init", "DelTimeOutput= %f", d=(/DelTimeOutput/) )
   139:                  call MessageNotify( "M", &
   140:                    & "timeset_init", "NstepShort   = %d", i=(/NstepShort/) )
   141:                  call MessageNotify( "M", &
   142:                    & "timeset_init", "NstepOutput  = %d", i=(/NstepOutput/) )
   143:                end if
   144:                
   145:              end subroutine timeset_init
   146:            
   147:            
   148:              subroutine TimesetProgress
   149:            
   150:                implicit none
   151:            
   152:                ! ľ 
   153:                !
   154:                DelTimeLong = DelTimeLongSave
   155:                NstepShort  = NstepShortSave
   156:            
   157:                ! ʤ
   158:                !
   159:                TimeB = TimeN
   160:                TimeN = TimeA
   161:                TimeA = TimeA + DelTimeLong
   162:            
   163:              end subroutine TimesetProgress
   164:              
   165:            end module timeset
